Nested blocks in React Block Editor control

18 Nov 201824 minutes to read

Configure children

The Block Editor supports hierarchical content structures through the children property. This can be achieved by using the properties property that allows you to create nested blocks, which is applicable only for Quote, Callout and Collapsible blocks.

Child blocks can be configured with all the same properties as top-level blocks.

Configure parent id

To establish a clear parent-child relationship, the parentId of each child block must match the id of its parent block.

This structure is essential for maintaining nested relationships within the editor.

Configure collapsible blocks

You can render Collapsible blocks by setting the blockType property as CollapsibleParagraph or CollapsibleHeading. Collapsible blocks allow users to expand or collapse sections, providing a way to hide or show content as needed.

Configure levels

You can configure the CollapsibleHeading using the property level inside the properties property . The levels can be varied from level: 1 to level: 4.

Configure expanded state

You can control whether a block is expanded or collapsed using the isExpanded property. By default, this property is set to false, meaning the block will be collapsed initially. This setting is only applicable to Collapsible blocks.

Block type & properties

// Configuring CollapsibleHeading block
{
    blockType: 'CollapsibleHeading',
    properties:{
        level: 1, //level varies from 1 to 4
        isExpanded: true,
        children: [
            {
                //your content to be here..
            }
        ]
    }
}
// Configuring CollapsibleParagraph block
{
    blockType: 'CollapsibleParagraph',
    properties:{
        children: [
            {
               //your content to be here..
            }
        ]
    }
}

This example shows how to configure CollapsibleHeading and CollapsibleParagraph blocks.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { BlockEditorComponent, ContentType } from '@syncfusion/ej2-react-blockeditor';

function App() {
  const blocksData = [
    {
      blockType: 'CollapsibleHeading',
      content: [
        {
          contentType: ContentType.Text,
          content: 'Collapsible Section'
        }
      ],
      properties:{
      level: 1,
      isExpanded: true,
      children: [
        {
          blockType: 'Paragraph',
          content: [
            {
              contentType: ContentType.Text,
              content: 'This content is inside a toggle section and can be collapsed.'
            }
          ]
        }
      ]
    }
    },
    {
      blockType: 'CollapsibleParagraph',
      content: [
        {
          contentType: ContentType.Text,
          content: 'Toggle paragraph section'
        }
      ],
      properties:{
      isExpanded: false,
      children: [
        {
          blockType: 'Paragraph',
          content: [
            {
              contentType: ContentType.Text,
              content: 'This content is initially hidden because isExpanded is set to false.'
            }
          ]
        }
      ]
    }
    }
  ];

  return <BlockEditorComponent id="block-editor" blocks={blocksData}></BlockEditorComponent>;
}

export default App;
ReactDOM.render(<App />, document.getElementById('container'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { BlockEditorComponent, BlockModel, ContentType } from '@syncfusion/ej2-react-blockeditor';

function App() {
    const blocksData: BlockModel[] = [
    {
      blockType: 'CollapsibleHeading',
      content: [
        {
          contentType: ContentType.Text,
          content: 'Collapsible Section'
        }
      ],
      properties:{
        level: 1,
        isExpanded: true,
        children: [
          {
            blockType: 'Paragraph',
            content: [
              {
                contentType: ContentType.Text,
                content: 'This content is inside a toggle section and can be collapsed.'
              }
            ]
          }
        ]
    }
    },
    {
      blockType: 'CollapsibleParagraph',
      content: [
        {
          contentType: ContentType.Text,
          content: 'Toggle paragraph section'
        }
      ],
      properties:{
      isExpanded: false,
      children: [
        {
          blockType: 'Paragraph',
          content: [
            {
              contentType: ContentType.Text,
              content: 'This content is initially hidden because isExpanded is set to false.'
            }
          ]
        }
      ]
    }
    }
  ];

  return <BlockEditorComponent id="block-editor" blocks={blocksData}></BlockEditorComponent>;
}

export default App;
ReactDOM.render(<App />, document.getElementById('container'));

Configure placeholder

You can configure placeholder text for block using the placeholder property. This text appears when the block is empty. The default placeholder for collapsible heading and collapsible paragraph is Collapsible Heading{level} and Collapsible Paragraph respectively.

// Adding placeholder value to collapsible heading
{
    blockType: 'CollapsibleHeading',
    properties: {
        level: 2,
        placeholder: 'Heading block'
    }
}
//Adding placeholder value for collapsible paragraph
{
    blockType: 'CollapsibleParagraph',
    properties: { placeholder: 'Collapsible Paragraph'}
}

Configure quote block

Quote blocks are styled for displaying quotations or excerpts. Render a Quote block by setting the blockType to Quote. Editing is now more natural with multi‑line support—pressing Enter creates a new line inside the block, and pressing Enter again on an empty line exits the quote.

Block type & properties

// Adding quote block
{
    blockType: 'Quote',
    properties:{
        children:[{
            blockType: 'Paragraph',
            content: [
                contentType: 'Text',
                content: ''
            ]
        }]
    }
}

The following sample demonstrates how to configure quote block.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { BlockEditorComponent, ContentType } from '@syncfusion/ej2-react-blockeditor';

function App() {
  const blocksData = [
    {
      id: 'security-quote',
      blockType: 'Quote',
      properties:{
      children: [
        {
          parentId: 'security-quote',
          blockType: 'Heading',
          properties: { level: 3},
          content: [
            {
              contentType: ContentType.Text,
              content: 'Security Notice'
            }
          ]
        },
        {
          parentId: 'security-quote',
          blockType: 'Paragraph',
          content: [
            {
              contentType: ContentType.Text,
              content:
                'Always validate user input before processing to prevent security vulnerabilities.'
            }
          ]
        },
        {
          parentId: 'security-quote',
          blockType: 'Paragraph',
          content: [
            {
              contentType: ContentType.Text,
              content: 'Use HTTPS for all data transmission'
            }
          ],
        },
        {
          parentId: 'security-quote',
          blockType: 'Paragraph',
          content: [
            {
              contentType: ContentType.Text,
              content: 'Implement proper authentication mechanisms'
            }
          ],
        },
        {
          parentId: 'security-quote',
          blockType: 'Paragraph',
          content: [
            {
              contentType: ContentType.Text,
              content: 'Regularly update dependencies and libraries'
            }
          ],
        }
      ]
    }
    }
  ];

  return (
    <BlockEditorComponent
      id="blockEditor"
      blocks={blocksData}
    />
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('container'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { BlockEditorComponent, BlockModel, ContentType } from '@syncfusion/ej2-react-blockeditor';

function App() {
  const blocksData: BlockModel[] = [
    {
      id: 'security-quote',
      blockType: 'Quote',
      properties:{
      children: [
            { 
                parentId: 'security-quote',
                blockType: 'Heading',
                properties: { level: 3},
                content: [{
                    contentType: ContentType.Text,
                    content: 'Security Notice'
                }]
            },
            { 
                parentId: 'security-quote',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Always validate user input before processing to prevent security vulnerabilities.'
                }]
            },
            { 
                parentId: 'security-quote',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Use HTTPS for all data transmission'
                }],
            },
            { 
                parentId: 'security-quote',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Implement proper authentication mechanisms'
                }],
            },
            { 
                parentId: 'security-quote',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Regularly update dependencies and libraries'
                }],
            }
      ]  
    }
    }
  ];

  return (
    <BlockEditorComponent id="blockEditor" blocks={blocksData}/>
  );
}

export default App;
ReactDOM.render(<App />, document.getElementById('container'));

Configure callout block

Callout blocks highlight important information such as notes, warnings, or tips. Render one by setting the blockType to Callout.

Block type & properties

// Adding callout block
  {
    blockType: 'Callout',
    properties:{
        children: [{ 
            blockType: 'Paragraph',
            content: [{
                contentType: 'Text',
                content: 'Important information: This is a callout block used to highlight important content.'
            }]
        }]
    }
 }

The following sample demonstrates how to configure callout block.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { BlockEditorComponent, ContentType } from '@syncfusion/ej2-react-blockeditor';

function App() {
  const blocksData = [
    {
      id: 'security-callout',
      blockType: 'Callout',
      properties:{
      children: [
        {
          id: 'security-title',
          parentId: 'security-callout',
          blockType: 'Heading',
          properties: { level: 3},
          content: [
            {
              contentType: ContentType.Text,
              content: 'Security Notice'
            }
          ]
        },
        {
          id: 'security-warning',
          parentId: 'security-callout',
          blockType: 'Paragraph',
          content: [
            {
              contentType: ContentType.Text,
              content:
                'Always validate user input before processing to prevent security vulnerabilities.'
            }
          ]
        },
        {
          id: 'security-tips',
          parentId: 'security-callout',
          blockType: 'Paragraph',
          content: [
            {
              contentType: ContentType.Text,
              content: 'Use HTTPS for all data transmission'
            }
          ],
          indent: 1
        },
        {
          id: 'security-tips-2',
          parentId: 'security-callout',
          blockType: 'Paragraph',
          content: [
            {
              contentType: ContentType.Text,
              content: 'Implement proper authentication mechanisms'
            }
          ],
          indent: 1
        },
        {
          id: 'security-tips-3',
          parentId: 'security-callout',
          blockType: 'Paragraph',
          content: [
            {
              contentType: ContentType.Text,
              content: 'Regularly update dependencies and libraries'
            }
          ],
          indent: 1
        }
      ]
    }
    }
  ];

  return (
    <BlockEditorComponent
      id="blockEditor"
      blocks={blocksData}
    />
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('container'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { BlockEditorComponent, BlockModel, ContentType } from '@syncfusion/ej2-react-blockeditor';

function App() {
  const blocksData: BlockModel[] = [
    {
      id: 'security-callout',
      blockType: 'Callout',
      properties:{
      children: [
            { 
                parentId: 'security-callout',
                blockType: 'Heading',
                properties: { level: 3},
                content: [{
                    contentType: ContentType.Text,
                    content: 'Security Notice'
                }]
            },
            { 
                parentId: 'security-callout',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Always validate user input before processing to prevent security vulnerabilities.'
                }]
            },
            { 
                parentId: 'security-callout',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Use HTTPS for all data transmission'
                }],
                indent: 1
            },
            { 
                parentId: 'security-callout',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Implement proper authentication mechanisms'
                }],
                indent: 1
            },
            { 
                parentId: 'security-callout',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Regularly update dependencies and libraries'
                }],
                indent: 1
            }
      ]  
    }
    }
  ];

  return (
    <BlockEditorComponent id="blockEditor" blocks={blocksData}/>
  );
}

export default App;
ReactDOM.render(<App />, document.getElementById('container'));

Nested blocks in Angular Block Editor control

18 Nov 201824 minutes to read

Configure children

The Block Editor supports hierarchical content structures through the children property. This can be achieved by using the properties property that allows you to create nested blocks, which is applicable only for Quote, Callout and Collapsible blocks.

Child blocks can be configured with all the same properties as top-level blocks.

Configure parent id

To establish a clear parent-child relationship, the parentId of each child block must match the id of its parent block.

This structure is essential for maintaining nested relationships within the editor.

Configure collapsible blocks

You can render Collapsible blocks by setting the blockType property as CollapsibleParagraph or CollapsibleHeading. Collapsible blocks allow users to expand or collapse sections, providing a way to hide or show content as needed.

Configure levels

You can configure the CollapsibleHeading using the property level inside the properties property . The levels can be varied from level: 1 to level: 4.

Configure expanded state

You can control whether a block is expanded or collapsed using the isExpanded property. By default, this property is set to false, meaning the block will be collapsed initially. This setting is only applicable to Collapsible blocks.

Block type & properties

// Configuring CollapsibleHeading block
{
    blockType: 'CollapsibleHeading',
    properties:{
        level: 1, //level varies from 1 to 4
        isExpanded: true,
        children: [
            {
                //your content to be here..
            }
        ]
    }
}
// Configuring CollapsibleParagraph block
{
    blockType: 'CollapsibleParagraph',
    properties:{
        children: [
            {
               //your content to be here..
            }
        ]
    }
}

This example shows how to configure CollapsibleHeading and CollapsibleParagraph blocks.

import { Component } from '@angular/core';
import { BlockEditorModule } from "@syncfusion/ej2-angular-blockeditor";
import { BlockModel, ContentType} from "@syncfusion/ej2-blockeditor";

@Component({
    imports: [BlockEditorModule],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.component.html'
})


export class AppComponent {
    public blocksData: BlockModel[] = [
        {
            blockType: 'CollapsibleHeading',
            content: [
                {
                    contentType: ContentType.Text,
                    content: 'Collapsible Section'
                }
            ],
            properties:{
                level: 1,
                isExpanded: true,
                children: [
                    {
                        blockType: 'Paragraph',
                        content: [
                            {
                                contentType: ContentType.Text,
                                content: 'This content is inside a toggle section and can be collapsed.'
                            }
                        ]
                    }
                ]
            }
        },
        {
            blockType: 'CollapsibleParagraph',
            content: [
                {
                    contentType: ContentType.Text,
                    content: 'Toggle paragraph section'
                }
            ],
            properties:{
                isExpanded: false,
                children: [
                    {
                        blockType: 'Paragraph',
                        content: [
                            {
                                contentType: ContentType.Text,
                                content: 'This content is initially hidden because isExpanded is set to false.'
                            }
                        ]
                    }
                ]
            }
        }
    ];

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
<div id="container">
    <ejs-blockeditor id="blockeditor" [blocks]="blocksData" />
</div>

Configure placeholder

You can configure placeholder text for block using the placeholder property. This text appears when the block is empty. The default placeholder for collapsible heading and collapsible paragraph is Collapsible Heading{level} and Collapsible Paragraph respectively.

// Adding placeholder value to collapsible heading
{
    blockType: 'CollapsibleHeading',
    properties: {
        level: 2,
        placeholder: 'Heading block'
    }
}
//Adding placeholder value for collapsible paragraph
{
    blockType: 'CollapsibleParagraph',
    properties: { placeholder: 'Collapsible Paragraph'}
}

Configure quote block

Quote blocks are styled for displaying quotations or excerpts. Render a Quote block by setting the blockType to Quote. Editing is now more natural with multi‑line support—pressing Enter creates a new line inside the block, and pressing Enter again on an empty line exits the quote.

Block type & properties

// Adding quote block
{
    blockType: 'Quote',
    properties:{
        children:[{
            blockType: 'Paragraph',
            content: [
                contentType: 'Text',
                content: ''
            ]
        }]
    }
}

The following sample demonstrates how to configure quote block.

import { Component } from '@angular/core';
import { BlockEditorModule } from "@syncfusion/ej2-angular-blockeditor";
import { BlockModel, ContentType} from "@syncfusion/ej2-blockeditor";

@Component({
    imports: [BlockEditorModule],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.component.html'
})


export class AppComponent {
    public blocksData: BlockModel[] = [
        {
            id: 'security-quote',
            blockType: 'Quote',
            properties: {
                children: [
                    { 
                        parentId: 'security-quote',
                        blockType: 'Heading',
                        properties: { level: 3},
                        content: [{
                            contentType: ContentType.Text,
                            content: 'Security Notice'
                        }]
                    },
                    { 
                        parentId: 'security-quote',
                        blockType: 'Paragraph',
                        content: [{
                            contentType: ContentType.Text,
                            content: 'Always validate user input before processing to prevent security vulnerabilities.'
                        }]
                    },
                    { 
                        parentId: 'security-quote',
                        blockType: 'Paragraph',
                        content: [{
                            contentType: ContentType.Text,
                            content: 'Use HTTPS for all data transmission'
                        }],
                    },
                    { 
                        parentId: 'security-quote',
                        blockType: 'Paragraph',
                        content: [{
                            contentType: ContentType.Text,
                            content: 'Implement proper authentication mechanisms'
                        }],
                    },
                    { 
                        parentId: 'security-quote',
                        blockType: 'Paragraph',
                        content: [{
                            contentType: ContentType.Text,
                            content: 'Regularly update dependencies and libraries'
                        }],
                    }
                ]
            }
        }
    ];
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
<div id="container">
    <ejs-blockeditor id="blockeditor" [blocks]="blocksData" />
</div>

Configure callout block

Callout blocks highlight important information such as notes, warnings, or tips. Render one by setting the blockType to Callout.

Block type & properties

// Adding callout block
  {
    blockType: 'Callout',
    properties:{
        children: [{ 
            blockType: 'Paragraph',
            content: [{
                contentType: 'Text',
                content: 'Important information: This is a callout block used to highlight important content.'
            }]
        }]
    }
 }

The following sample demonstrates how to configure callout block.

import { Component } from '@angular/core';
import { BlockEditorModule } from "@syncfusion/ej2-angular-blockeditor";
import { BlockModel, ContentType} from "@syncfusion/ej2-blockeditor";

@Component({
    imports: [BlockEditorModule],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.component.html'
})


export class AppComponent {
    public blocksData: BlockModel[] = [
        {
            id: 'security-callout',
            blockType: 'Callout',
            properties: {
                children: [
                    { 
                        parentId: 'security-callout',
                        blockType: 'Heading',
                        properties: { level: 3},
                        content: [{
                            contentType: ContentType.Text,
                            content: 'Security Notice'
                        }]
                    },
                    { 
                        parentId: 'security-callout',
                        blockType: 'Paragraph',
                        content: [{
                            contentType: ContentType.Text,
                            content: 'Always validate user input before processing to prevent security vulnerabilities.'
                        }]
                    },
                    { 
                        parentId: 'security-callout',
                        blockType: 'Paragraph',
                        content: [{
                            contentType: ContentType.Text,
                            content: 'Use HTTPS for all data transmission'
                        }],
                        indent: 1
                    },
                    { 
                        parentId: 'security-callout',
                        blockType: 'Paragraph',
                        content: [{
                            contentType: ContentType.Text,
                            content: 'Implement proper authentication mechanisms'
                        }],
                        indent: 1
                    },
                    { 
                        parentId: 'security-callout',
                        blockType: 'Paragraph',
                        content: [{
                            contentType: ContentType.Text,
                            content: 'Regularly update dependencies and libraries'
                        }],
                        indent: 1
                    }
                ]
            }
        }
    ];

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
<div id="container">
    <ejs-blockeditor id="blockeditor" [blocks]="blocksData" />
</div>

Nested blocks in Vue Block Editor control

18 Nov 201824 minutes to read

Configure children

The Block Editor supports hierarchical content structures through the children property. This can be achieved by using the properties property that allows you to create nested blocks, which is applicable only for Quote, Callout and Collapsible blocks.

Child blocks can be configured with all the same properties as top-level blocks.

Configure parent id

To establish a clear parent-child relationship, the parentId of each child block must match the id of its parent block.

This structure is essential for maintaining nested relationships within the editor.

Configure collapsible blocks

You can render Collapsible blocks by setting the blockType property as CollapsibleParagraph or CollapsibleHeading. Collapsible blocks allow users to expand or collapse sections, providing a way to hide or show content as needed.

Configure levels

You can configure the CollapsibleHeading using the property level inside the properties property . The levels can be varied from level: 1 to level: 4.

Configure expanded state

You can control whether a block is expanded or collapsed using the isExpanded property. By default, this property is set to false, meaning the block will be collapsed initially. This setting is only applicable to Collapsible blocks.

Block type & properties

// Configuring CollapsibleHeading block
{
    blockType: 'CollapsibleHeading',
    properties:{
        level: 1, //level varies from 1 to 4
        isExpanded: true,
        children: [
            {
                //your content to be here..
            }
        ]
    }
}
// Configuring CollapsibleParagraph block
{
    blockType: 'CollapsibleParagraph',
    properties:{
        children: [
            {
               //your content to be here..
            }
        ]
    }
}

This example shows how to configure CollapsibleHeading and CollapsibleParagraph blocks.

<template>
  <div id='container'>
    <ejs-blockeditor :blocks="blocksData"></ejs-blockeditor>
  </div>
</template>

<script setup>
import { BlockEditorComponent as EjsBlockeditor, ContentType  } from "@syncfusion/ej2-vue-blockeditor";

const blocksData = [
    {
        blockType: 'CollapsibleHeading',
        content: [
            {
                contentType: ContentType.Text,
                content: 'Collapsible Section'
            }
        ],
        properties: {
            level: 1,
            isExpanded: true,
            children: [
                {
                    blockType: 'Paragraph',
                    content: [
                        {
                            contentType: ContentType.Text,
                            content: 'This content is inside a toggle section and can be collapsed.'
                        }
                    ]
                }
            ]
        }
    },
    {
        blockType: 'CollapsibleParagraph',
        content: [
            {
                contentType: ContentType.Text,
                content: 'Toggle paragraph section'
            }
        ],
        properties: {
            isExpanded: false,
            children: [
                {
                    blockType: 'Paragraph',
                    content: [
                        {
                            contentType: ContentType.Text,
                            content: 'This content is initially hidden because isExpanded is set to false.'
                        }
                    ]
                }
            ]
        }
    }
];

</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>
<template>
  <div id='container'>
    <ejs-blockeditor :blocks="blocksData"></ejs-blockeditor>
  </div>
</template>

<script>
import { BlockEditorComponent, ContentType } from "@syncfusion/ej2-vue-blockeditor";

export default {
  components: {
    'ejs-blockeditor': BlockEditorComponent,
  },
  data() {
    return {
      blocksData: [
          {
              blockType: 'CollapsibleHeading',
              content: [
                  {
                      contentType: ContentType.Text,
                      content: 'Collapsible Section'
                  }
              ],
              properties: {
                level: 1,
                isExpanded: true,
                children: [
                    {
                        blockType: 'Paragraph',
                        content: [
                            {
                                contentType: ContentType.Text,
                                content: 'This content is inside a toggle section and can be collapsed.'
                            }
                        ]
                    }
                ]
              }
          },
          {
              blockType: 'CollapsibleParagraph',
              content: [
                  {
                      contentType: ContentType.Text,
                      content: 'Toggle paragraph section'
                  }
              ],
              properties: {
                isExpanded: false,
                children: [
                    {
                        blockType: 'Paragraph',
                        content: [
                            {
                                contentType: ContentType.Text,
                                content: 'This content is initially hidden because isExpanded is set to false.'
                            }
                        ]
                    }
                ]
            }
          }
      ]
    };
  },
  methods: {
    
  }
};
</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>

Configure placeholder

You can configure placeholder text for block using the placeholder property. This text appears when the block is empty. The default placeholder for collapsible heading and collapsible paragraph is Collapsible Heading{level} and Collapsible Paragraph respectively.

// Adding placeholder value to collapsible heading
{
    blockType: 'CollapsibleHeading',
    properties: {
        level: 2,
        placeholder: 'Heading block'
    }
}
//Adding placeholder value for collapsible paragraph
{
    blockType: 'CollapsibleParagraph',
    properties: { placeholder: 'Collapsible Paragraph'}
}

Configure quote block

Quote blocks are styled for displaying quotations or excerpts. Render a Quote block by setting the blockType to Quote. Editing is now more natural with multi‑line support—pressing Enter creates a new line inside the block, and pressing Enter again on an empty line exits the quote.

Block type & properties

// Adding quote block
{
    blockType: 'Quote',
    properties:{
        children:[{
            blockType: 'Paragraph',
            content: [
                contentType: 'Text',
                content: ''
            ]
        }]
    }
}

The following sample demonstrates how to configure quote block.

<template>
  <div id='container'>
    <ejs-blockeditor :blocks="blocksData"></ejs-blockeditor>
  </div>
</template>

<script setup>
import { BlockEditorComponent as EjsBlockeditor, ContentType } from "@syncfusion/ej2-vue-blockeditor";

const blocksData = [
    {
        id: 'security-quote',
        blockType: 'Quote',
        properties: {
        children: [
            { 
                parentId: 'security-quote',
                blockType: 'Heading',
                props: { level: 3},
                content: [{
                    contentType: ContentType.Text,
                    content: 'Security Notice'
                }]
            },
            { 
                parentId: 'security-quote',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Always validate user input before processing to prevent security vulnerabilities.'
                }]
            },
            { 
                parentId: 'security-quote',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Use HTTPS for all data transmission'
                }],
            },
            { 
                parentId: 'security-quote',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Implement proper authentication mechanisms'
                }],
            },
            { 
                parentId: 'security-quote',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Regularly update dependencies and libraries'
                }],
            }
        ]
        }
    }
];

</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>
<template>
  <div id='container'>
    <ejs-blockeditor :blocks="blocksData"></ejs-blockeditor>
  </div>
</template>

<script>
import { BlockEditorComponent, ContentType } from "@syncfusion/ej2-vue-blockeditor";

export default {
  components: {
    'ejs-blockeditor': BlockEditorComponent,
  },
  data() {
    return {
      blocksData: [
            {
              id: 'security-quote',
              blockType: 'Quote',
              properties: {
              children: [
                  { 
                      parentId: 'security-quote',
                      blockType: 'Heading',
                      properties: { level: 3},
                      content: [{
                          contentType: ContentType.Text,
                          content: 'Security Notice'
                      }]
                  },
                  { 
                      parentId: 'security-quote',
                      blockType: 'Paragraph',
                      content: [{
                          contentType: ContentType.Text,
                          content: 'Always validate user input before processing to prevent security vulnerabilities.'
                      }]
                  },
                  { 
                      parentId: 'security-quote',
                      blockType: 'Paragraph',
                      content: [{
                          contentType: ContentType.Text,
                          content: 'Use HTTPS for all data transmission'
                      }],
                  },
                  { 
                      parentId: 'security-quote',
                      blockType: 'Paragraph',
                      content: [{
                          contentType: ContentType.Text,
                          content: 'Implement proper authentication mechanisms'
                      }],
                  },
                  { 
                      parentId: 'security-quote',
                      blockType: 'Paragraph',
                      content: [{
                          contentType: ContentType.Text,
                          content: 'Regularly update dependencies and libraries'
                      }],
                  }
              ]
              }
          }
      ]
    };
  },
  methods: {
    
  }
};
</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>

Configure callout block

Callout blocks highlight important information such as notes, warnings, or tips. Render one by setting the blockType to Callout.

Block type & properties

// Adding callout block
  {
    blockType: 'Callout',
    properties:{
        children: [{ 
            blockType: 'Paragraph',
            content: [{
                contentType: 'Text',
                content: 'Important information: This is a callout block used to highlight important content.'
            }]
        }]
    }
 }

The following sample demonstrates how to configure callout block.

<template>
  <div id='container'>
    <ejs-blockeditor :blocks="blocksData"></ejs-blockeditor>
  </div>
</template>

<script setup>
import { BlockEditorComponent as EjsBlockeditor, ContentType } from "@syncfusion/ej2-vue-blockeditor";

const blocksData = [
    {
        id: 'security-callout',
        blockType: 'Callout',
        properties: {
        children: [
            { 
                parentId: 'security-callout',
                blockType: 'Heading',
                props: { level: 3},
                content: [{
                    contentType: ContentType.Text,
                    content: 'Security Notice'
                }]
            },
            { 
                parentId: 'security-callout',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Always validate user input before processing to prevent security vulnerabilities.'
                }]
            },
            { 
                parentId: 'security-callout',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Use HTTPS for all data transmission'
                }],
                indent: 1
            },
            { 
                parentId: 'security-callout',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Implement proper authentication mechanisms'
                }],
                indent: 1
            },
            { 
                parentId: 'security-callout',
                blockType: 'Paragraph',
                content: [{
                    contentType: ContentType.Text,
                    content: 'Regularly update dependencies and libraries'
                }],
                indent: 1
            }
        ]
        }
    }
];

</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>
<template>
  <div id='container'>
    <ejs-blockeditor :blocks="blocksData"></ejs-blockeditor>
  </div>
</template>

<script>
import { BlockEditorComponent, ContentType } from "@syncfusion/ej2-vue-blockeditor";

export default {
  components: {
    'ejs-blockeditor': BlockEditorComponent,
  },
  data() {
    return {
      blocksData: [
            {
              id: 'security-callout',
              blockType: 'Callout',
              properties: {
              children: [
                  { 
                      parentId: 'security-callout',
                      blockType: 'Heading',
                      properties: { level: 3},
                      content: [{
                          contentType: ContentType.Text,
                          content: 'Security Notice'
                      }]
                  },
                  { 
                      parentId: 'security-callout',
                      blockType: 'Paragraph',
                      content: [{
                          contentType: ContentType.Text,
                          content: 'Always validate user input before processing to prevent security vulnerabilities.'
                      }]
                  },
                  { 
                      parentId: 'security-callout',
                      blockType: 'Paragraph',
                      content: [{
                          contentType: ContentType.Text,
                          content: 'Use HTTPS for all data transmission'
                      }],
                      indent: 1
                  },
                  { 
                      parentId: 'security-callout',
                      blockType: 'Paragraph',
                      content: [{
                          contentType: ContentType.Text,
                          content: 'Implement proper authentication mechanisms'
                      }],
                      indent: 1
                  },
                  { 
                      parentId: 'security-callout',
                      blockType: 'Paragraph',
                      content: [{
                          contentType: ContentType.Text,
                          content: 'Regularly update dependencies and libraries'
                      }],
                      indent: 1
                  }
              ]
              }
          }
      ]
    };
  },
  methods: {
    
  }
};
</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>